Job¶
Job¶
Tracks asynchronous work being done within a project
Variables
| Attribute | Type | Description |
|---|---|---|
id |
int |
The ID of the job |
project_id |
str |
The ID of the project the job belongs to |
status |
str |
The status of the job - will be one of datarobot.enums.QUEUE_STATUS |
job_type |
str |
What kind of work the job is doing - will be one of datarobot.enums.JOB_TYPE |
is_blocked |
bool |
If true, the job is blocked (cannot be executed) until its dependencies are resolved |
get()¶
Fetches one job.
Parameters
| Parameter | Type | Description |
|---|---|---|
project_id |
str |
The identifier of the project in which the job resides |
job_id |
str |
The job id |
Returns
| Returns | Description |
|---|---|
| job | The job |
Return type: Job
Raises
| Exception | Description |
|---|---|
| AsyncFailureError | Querying this resource gave a status code other than 200 or 303 |
cancel()¶
Cancel this job. If this job has not finished running, it will be removed and canceled.
Return type: None
get_result()¶
Parameters
| Parameter | Type | Description |
|---|---|---|
params |
dict or None |
Query parameters to be added to request to get results. |
Notes
For featureEffects, source param is required to define source, otherwise the default is training.
Returns
| Returns | Description |
|---|---|
| result | Return type depends on the job type : - for model jobs, a Model is returned - for predict jobs, a pandas.DataFrame (with predictions) is returned - for featureImpact jobs, a list of dicts by default (see with_metadata parameter of the FeatureImpactJob class and its get() method). - for primeRulesets jobs, a list of Rulesets - for primeModel jobs, a PrimeModel - for primeDownloadValidation jobs, a PrimeFile - for predictionExplanationInitialization jobs, a PredictionExplanationsInitialization - for predictionExplanations jobs, a PredictionExplanations - for featureEffects, a FeatureEffects. |
Return type: object
Raises
| Exception | Description |
|---|---|
| JobNotFinished | If the job is not finished, the result is not available. |
| AsyncProcessUnsuccessfulError | If the job errored or was aborted |
get_result_when_complete()¶
Parameters
| Parameter | Type | Description |
|---|---|---|
max_wait |
Optional[int] |
How long to wait for the job to finish. |
params |
dict, optional |
Query parameters to be added to request. |
Returns
| Returns | Description |
|---|---|
| result | Return type is the same as would be returned by Job.get_result. |
Return type: object
Raises
| Exception | Description |
|---|---|
| AsyncTimeoutError | If the job does not finish in time |
| AsyncProcessUnsuccessfulError | If the job errored or was aborted |
refresh()¶
Update this object with the latest job data from the server.
Return type: None
wait_for_completion()¶
Waits for job to complete.
Parameters
| Parameter | Type | Description |
|---|---|---|
max_wait |
Optional[int] |
How long to wait for the job to finish. |
Return type: None
TrainingPredictionsJob¶
get()¶
Fetches one training predictions job.
The resulting
TrainingPredictions
object will be annotated with model_id and data_subset.
Parameters
| Parameter | Type | Description |
|---|---|---|
project_id |
str |
The identifier of the project in which the job resides |
job_id |
str |
The job id |
model_id |
str |
The identifier of the model used for computing training predictions |
data_subset |
dr.enums.DATA_SUBSET, optional |
Data subset used for computing training predictions |
Returns
| Returns | Description |
|---|---|
| job | The job |
Return type: TrainingPredictionsJob
refresh()¶
Update this object with the latest job data from the server.
Return type: None
cancel()¶
Cancel this job. If this job has not finished running, it will be removed and canceled.
Return type: None
get_result()¶
Parameters
| Parameter | Type | Description |
|---|---|---|
params |
dict or None |
Query parameters to be added to request to get results. |
Notes
For featureEffects, source param is required to define source, otherwise the default is training.
Returns
| Returns | Description |
|---|---|
| result | Return type depends on the job type : - for model jobs, a Model is returned - for predict jobs, a pandas.DataFrame (with predictions) is returned - for featureImpact jobs, a list of dicts by default (see with_metadata parameter of the FeatureImpactJob class and its get() method). - for primeRulesets jobs, a list of Rulesets - for primeModel jobs, a PrimeModel - for primeDownloadValidation jobs, a PrimeFile - for predictionExplanationInitialization jobs, a PredictionExplanationsInitialization - for predictionExplanations jobs, a PredictionExplanations - for featureEffects, a FeatureEffects. |
Return type: object
Raises
| Exception | Description |
|---|---|
| JobNotFinished | If the job is not finished, the result is not available. |
| AsyncProcessUnsuccessfulError | If the job errored or was aborted |
get_result_when_complete()¶
Parameters
| Parameter | Type | Description |
|---|---|---|
max_wait |
Optional[int] |
How long to wait for the job to finish. |
params |
dict, optional |
Query parameters to be added to request. |
Returns
| Returns | Description |
|---|---|
| result | Return type is the same as would be returned by Job.get_result. |
Return type: object
Raises
| Exception | Description |
|---|---|
| AsyncTimeoutError | If the job does not finish in time |
| AsyncProcessUnsuccessfulError | If the job errored or was aborted |
wait_for_completion()¶
Waits for job to complete.
Parameters
| Parameter | Type | Description |
|---|---|---|
max_wait |
Optional[int] |
How long to wait for the job to finish. |
Return type: None
ShapMatrixJob¶
get()¶
Fetches one SHAP matrix job.
Parameters
| Parameter | Type | Description |
|---|---|---|
project_id |
str |
The identifier of the project in which the job resides |
job_id |
str |
The job identifier |
model_id |
str |
The identifier of the model used for computing prediction explanations |
dataset_id |
str |
The identifier of the dataset against which prediction explanations should be computed |
Returns
| Returns | Description |
|---|---|
| job | The job |
Return type: ShapMatrixJob
Raises
| Exception | Description |
|---|---|
| AsyncFailureError | Querying this resource gave a status code other than 200 or 303 |
refresh()¶
Update this object with the latest job data from the server.
Return type: None
cancel()¶
Cancel this job. If this job has not finished running, it will be removed and canceled.
Return type: None
get_result()¶
Parameters
| Parameter | Type | Description |
|---|---|---|
params |
dict or None |
Query parameters to be added to request to get results. |
Notes
For featureEffects, source param is required to define source, otherwise the default is training.
Returns
| Returns | Description |
|---|---|
| result | Return type depends on the job type : - for model jobs, a Model is returned - for predict jobs, a pandas.DataFrame (with predictions) is returned - for featureImpact jobs, a list of dicts by default (see with_metadata parameter of the FeatureImpactJob class and its get() method). - for primeRulesets jobs, a list of Rulesets - for primeModel jobs, a PrimeModel - for primeDownloadValidation jobs, a PrimeFile - for predictionExplanationInitialization jobs, a PredictionExplanationsInitialization - for predictionExplanations jobs, a PredictionExplanations - for featureEffects, a FeatureEffects. |
Return type: object
Raises
| Exception | Description |
|---|---|
| JobNotFinished | If the job is not finished, the result is not available. |
| AsyncProcessUnsuccessfulError | If the job errored or was aborted |
get_result_when_complete()¶
Parameters
| Parameter | Type | Description |
|---|---|---|
max_wait |
Optional[int] |
How long to wait for the job to finish. |
params |
dict, optional |
Query parameters to be added to request. |
Returns
| Returns | Description |
|---|---|
| result | Return type is the same as would be returned by Job.get_result. |
Return type: object
Raises
| Exception | Description |
|---|---|
| AsyncTimeoutError | If the job does not finish in time |
| AsyncProcessUnsuccessfulError | If the job errored or was aborted |
wait_for_completion()¶
Waits for job to complete.
Parameters
| Parameter | Type | Description |
|---|---|---|
max_wait |
Optional[int] |
How long to wait for the job to finish. |
Return type: None
FeatureImpactJob¶
Custom Feature Impact job to handle different return value structures.
The original implementation had just the the data and the new one also includes some metadata.
In general, we aim to keep the number of Job classes low by just utilizing the job_type attribute to control any specific formatting; however in this case when we needed to support a new representation with the _same_ job_type, customizing the behavior of _make_result_from_location allowed us to achieve our ends without complicating the _make_result_from_json method.
get()¶
Fetches one job.
Parameters
| Parameter | Type | Description |
|---|---|---|
project_id |
str |
The identifier of the project in which the job resides |
job_id |
str |
The job id |
with_metadata |
bool |
To make this job return the metadata (i.e., the full object of the completed resource) set the with_metadata flag to True. |
Returns
| Returns | Description |
|---|---|
| job | The job |
Return type: Job
Raises
| Exception | Description |
|---|---|
| AsyncFailureError | Querying this resource gave a status code other than 200 or 303 |
cancel()¶
Cancel this job. If this job has not finished running, it will be removed and canceled.
Return type: None
get_result()¶
Parameters
| Parameter | Type | Description |
|---|---|---|
params |
dict or None |
Query parameters to be added to request to get results. |
Notes
For featureEffects, source param is required to define source, otherwise the default is training.
Returns
| Returns | Description |
|---|---|
| result | Return type depends on the job type : - for model jobs, a Model is returned - for predict jobs, a pandas.DataFrame (with predictions) is returned - for featureImpact jobs, a list of dicts by default (see with_metadata parameter of the FeatureImpactJob class and its get() method). - for primeRulesets jobs, a list of Rulesets - for primeModel jobs, a PrimeModel - for primeDownloadValidation jobs, a PrimeFile - for predictionExplanationInitialization jobs, a PredictionExplanationsInitialization - for predictionExplanations jobs, a PredictionExplanations - for featureEffects, a FeatureEffects. |
Return type: object
Raises
| Exception | Description |
|---|---|
| JobNotFinished | If the job is not finished, the result is not available. |
| AsyncProcessUnsuccessfulError | If the job errored or was aborted |
get_result_when_complete()¶
Parameters
| Parameter | Type | Description |
|---|---|---|
max_wait |
Optional[int] |
How long to wait for the job to finish. |
params |
dict, optional |
Query parameters to be added to request. |
Returns
| Returns | Description |
|---|---|
| result | Return type is the same as would be returned by Job.get_result. |
Return type: object
Raises
| Exception | Description |
|---|---|
| AsyncTimeoutError | If the job does not finish in time |
| AsyncProcessUnsuccessfulError | If the job errored or was aborted |
refresh()¶
Update this object with the latest job data from the server.
Return type: None
wait_for_completion()¶
Waits for job to complete.
Parameters
| Parameter | Type | Description |
|---|---|---|
max_wait |
Optional[int] |
How long to wait for the job to finish. |
Return type: None